extends Window


@export var WorldTiles : TileMapLayer
@export_category("Node Assignments")
@export var LeftMouseSelector : MenuButton
@export var RightMouseSelector : MenuButton


var leftMouseTile : int = Globals.WALL
var rightMouseTile : int = Globals.AIR

# Called when the node enters the scene tree for the first time.
func _ready() -> void:
	LeftMouseSelector.get_popup().id_pressed.connect(_on_mouse_selector_pressed)
	RightMouseSelector.get_popup().id_pressed.connect(_on_mouse_selector_pressed)


# Called every frame. 'delta' is the elapsed time since the previous frame.
func _process(delta: float) -> void:
	if Input.is_mouse_button_pressed(MOUSE_BUTTON_LEFT):
		var setPos : Vector2i = WorldTiles.local_to_map(WorldTiles.get_local_mouse_position())
		WorldTiles.set_cell(setPos,leftMouseTile,Vector2i(0,0))

	if Input.is_mouse_button_pressed(MOUSE_BUTTON_RIGHT):
		var setPos : Vector2i = WorldTiles.local_to_map(WorldTiles.get_local_mouse_position())
		WorldTiles.set_cell(setPos,rightMouseTile,Vector2i(0,0))

func _on_mouse_selector_pressed(mouse : int, id: int) -> void:
	pass
